unit RowGrid_TLB;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : $Revision:   1.130  $
// File generated on 2006-09-07 22:09:48 from Type Library described below.

// ************************************************************************  //
// Type Lib: RowGrid.ocx (freeware)
// LIBID: {A5AA4A02-3A94-470E-A722-A5E960728FCC}
// LCID: 0
// Helpfile: 
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\system32\stdole2.tlb)
//   (2) v4.0 StdVCL, (C:\WINDOWS\system32\stdvcl40.dll)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}

interface

uses ActiveX, Classes, Graphics, OleCtrls, OleServer, StdVCL, Variants, 
Windows;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  RowGridMajorVersion = 1;
  RowGridMinorVersion = 0;

  LIBID_RowGrid: TGUID = '{A5AA4A02-3A94-470E-A722-A5E960728FCC}';

  IID_IRowGridX: TGUID = '{4925E453-CF76-4DB6-B490-B281D1A9431F}';
  DIID_IRowGridXEvents: TGUID = '{6A7E7D31-E04C-4D89-B086-5FDE2D6921DB}';
  CLASS_RowGridX: TGUID = '{453EF49A-BA60-48E8-800D-46116526C471}';
  IID_IRowCellX: TGUID = '{12F262C0-20DE-4A15-9EE7-189E98A8BF20}';
  CLASS_RowCellX: TGUID = '{6D7B68E9-C371-44AC-849E-2F60DB0FE8D2}';
  IID_IRectX: TGUID = '{346DE116-0A7F-4392-BD6F-6091FE2D9DA7}';
  CLASS_RectX: TGUID = '{719EABE5-DBD1-453D-8C19-385DEA02B054}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum TxDragState
type
  TxDragState = TOleEnum;
const
  dsDragDrop = $00000000;
  dsCopyDrop = $00000001;
  dsInsert = $00000002;
  dsNone = $00000003;

// Constants for enum TxDragMode
type
  TxDragMode = TOleEnum;
const
  dmManual = $00000000;
  dmAutomatic = $00000001;

// Constants for enum TxCellState
type
  TxCellState = TOleEnum;
const
  csLeft = $00000000;
  csCenter = $00000001;
  csRight = $00000002;
  csEmpty = $00000003;
  csNone = $00000004;

// Constants for enum TxMouseButton
type
  TxMouseButton = TOleEnum;
const
  mbLeft = $00000000;
  mbRight = $00000001;
  mbMiddle = $00000002;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IRowGridX = interface;
  IRowGridXDisp = dispinterface;
  IRowGridXEvents = dispinterface;
  IRowCellX = interface;
  IRectX = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  RowGridX = IRowGridX;
  RowCellX = IRowCellX;
  RectX = IRectX;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  PPUserType1 = ^IFontDisp; {*}

  TxRowCell = packed record
    Row: SYSINT;
    Start: SYSINT;
    Units: SYSINT;
    Zorder: SYSINT;
    ObjectPtr: Pointer;
  end;

  TxRect = packed record
    Left: SYSINT;
    Top: SYSINT;
    Right: SYSINT;
    Bottom: SYSINT;
  end;


// *********************************************************************//
// Interface: IRowGridX
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {4925E453-CF76-4DB6-B490-B281D1A9431F}
// *********************************************************************//
  IRowGridX = interface(IDispatch)
    ['{4925E453-CF76-4DB6-B490-B281D1A9431F}']
    function  Get_DragState: TxDragState; safecall;
    procedure ClearDragState(out RowCellX: IRowCellX); safecall;
    function  Get_Units: Integer; safecall;
    procedure Set_Units(Value: Integer); safecall;
    function  Get_TickColor: OLE_COLOR; safecall;
    procedure Set_TickColor(Value: OLE_COLOR); safecall;
    function  Get_RowCount: Integer; safecall;
    procedure Set_RowCount(Value: Integer); safecall;
    function  Get_RowHeight: Integer; safecall;
    procedure Set_RowHeight(Value: Integer); safecall;
    function  Get_RowLineWidth: Integer; safecall;
    procedure Set_RowLineWidth(Value: Integer); safecall;
    function  Get_UnitWidth: Integer; safecall;
    procedure Set_UnitWidth(Value: Integer); safecall;
    function  Get_FrameWidth: Integer; safecall;
    procedure Set_FrameWidth(Value: Integer); safecall;
    function  Get_CellFrameWidth: Integer; safecall;
    procedure Set_CellFrameWidth(Value: Integer); safecall;
    function  Get_CellBorderWidth: Integer; safecall;
    procedure Set_CellBorderWidth(Value: Integer); safecall;
    function  Get_DefaultDrawing: WordBool; safecall;
    procedure Set_DefaultDrawing(Value: WordBool); safecall;
    function  Get_CheckPosition: WordBool; safecall;
    procedure Set_CheckPosition(Value: WordBool); safecall;
    function  Get_CrossBorders: WordBool; safecall;
    procedure Set_CrossBorders(Value: WordBool); safecall;
    function  Get_MinVisible: Integer; safecall;
    procedure Set_MinVisible(Value: Integer); safecall;
    function  Get_RowLineColor: OLE_COLOR; safecall;
    procedure Set_RowLineColor(Value: OLE_COLOR); safecall;
    function  Get_CellColor: OLE_COLOR; safecall;
    procedure Set_CellColor(Value: OLE_COLOR); safecall;
    function  Get_Ctl3D: WordBool; safecall;
    procedure Set_Ctl3D(Value: WordBool); safecall;
    function  Get_ParentCtl3D: WordBool; safecall;
    procedure Set_ParentCtl3D(Value: WordBool); safecall;
    function  Get_Color: OLE_COLOR; safecall;
    procedure Set_Color(Value: OLE_COLOR); safecall;
    function  Get_DragCursor: Smallint; safecall;
    procedure Set_DragCursor(Value: Smallint); safecall;
    function  Get_DragMode: TxDragMode; safecall;
    procedure Set_DragMode(Value: TxDragMode); safecall;
    function  Get_Enabled: WordBool; safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    function  Get_Font: IFontDisp; safecall;
    procedure Set_Font(const Value: IFontDisp); safecall;
    procedure _Set_Font(var Value: IFontDisp); safecall;
    function  Get_ParentColor: WordBool; safecall;
    procedure Set_ParentColor(Value: WordBool); safecall;
    function  Get_Visible: WordBool; safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    function  Get_DoubleBuffered: WordBool; safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    function  Get_AlignDisabled: WordBool; safecall;
    function  Get_VisibleDockClientCount: Integer; safecall;
    function  DrawTextBiDiModeFlagsReadingOnly: Integer; safecall;
    function  IsRightToLeft: WordBool; safecall;
    function  UseRightToLeftReading: WordBool; safecall;
    function  UseRightToLeftScrollBar: WordBool; safecall;
    procedure SetSubComponent(IsSubComponent: WordBool); safecall;
    procedure GetCellArray(out RowCells: PSafeArray; out ArraySize: Integer; Row: Integer); safecall;
    procedure InsertRowCell(Row: Integer; Start: Integer; Units: Integer; Zorder: Integer; 
                            ObjectPtr: Pointer); safecall;
    procedure RemoveRowCell(const RowCellX: IRowCellX); safecall;
    procedure MouseToCell(out RowCellX: IRowCellX; X: Integer; Y: Integer; 
                          out CellState: TxCellState); safecall;
    function  Get_ClientWidth: Integer; safecall;
    procedure Set_ClientWidth(Value: Integer); safecall;
    function  Get_ClientHeight: Integer; safecall;
    procedure Set_ClientHeight(Value: Integer); safecall;
    function  Get_HDC: Pointer; safecall;
    procedure ClearRow(Row: Integer); safecall;
    function  Get_VerticalRows: WordBool; safecall;
    procedure Set_VerticalRows(Value: WordBool); safecall;
    function  Get_AllowAltKey: WordBool; safecall;
    procedure Set_AllowAltKey(Value: WordBool); safecall;
    function  Get_AllowShiftKey: WordBool; safecall;
    procedure Set_AllowShiftKey(Value: WordBool); safecall;
    property DragState: TxDragState read Get_DragState;
    property Units: Integer read Get_Units write Set_Units;
    property TickColor: OLE_COLOR read Get_TickColor write Set_TickColor;
    property RowCount: Integer read Get_RowCount write Set_RowCount;
    property RowHeight: Integer read Get_RowHeight write Set_RowHeight;
    property RowLineWidth: Integer read Get_RowLineWidth write Set_RowLineWidth;
    property UnitWidth: Integer read Get_UnitWidth write Set_UnitWidth;
    property FrameWidth: Integer read Get_FrameWidth write Set_FrameWidth;
    property CellFrameWidth: Integer read Get_CellFrameWidth write Set_CellFrameWidth;
    property CellBorderWidth: Integer read Get_CellBorderWidth write Set_CellBorderWidth;
    property DefaultDrawing: WordBool read Get_DefaultDrawing write Set_DefaultDrawing;
    property CheckPosition: WordBool read Get_CheckPosition write Set_CheckPosition;
    property CrossBorders: WordBool read Get_CrossBorders write Set_CrossBorders;
    property MinVisible: Integer read Get_MinVisible write Set_MinVisible;
    property RowLineColor: OLE_COLOR read Get_RowLineColor write Set_RowLineColor;
    property CellColor: OLE_COLOR read Get_CellColor write Set_CellColor;
    property Ctl3D: WordBool read Get_Ctl3D write Set_Ctl3D;
    property ParentCtl3D: WordBool read Get_ParentCtl3D write Set_ParentCtl3D;
    property Color: OLE_COLOR read Get_Color write Set_Color;
    property DragCursor: Smallint read Get_DragCursor write Set_DragCursor;
    property DragMode: TxDragMode read Get_DragMode write Set_DragMode;
    property Enabled: WordBool read Get_Enabled write Set_Enabled;
    property Font: IFontDisp read Get_Font write Set_Font;
    property ParentColor: WordBool read Get_ParentColor write Set_ParentColor;
    property Visible: WordBool read Get_Visible write Set_Visible;
    property DoubleBuffered: WordBool read Get_DoubleBuffered write Set_DoubleBuffered;
    property AlignDisabled: WordBool read Get_AlignDisabled;
    property VisibleDockClientCount: Integer read Get_VisibleDockClientCount;
    property ClientWidth: Integer read Get_ClientWidth write Set_ClientWidth;
    property ClientHeight: Integer read Get_ClientHeight write Set_ClientHeight;
    property HDC: Pointer read Get_HDC;
    property VerticalRows: WordBool read Get_VerticalRows write Set_VerticalRows;
    property AllowAltKey: WordBool read Get_AllowAltKey write Set_AllowAltKey;
    property AllowShiftKey: WordBool read Get_AllowShiftKey write Set_AllowShiftKey;
  end;

// *********************************************************************//
// DispIntf:  IRowGridXDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {4925E453-CF76-4DB6-B490-B281D1A9431F}
// *********************************************************************//
  IRowGridXDisp = dispinterface
    ['{4925E453-CF76-4DB6-B490-B281D1A9431F}']
    property DragState: TxDragState readonly dispid 1;
    procedure ClearDragState(out RowCellX: IRowCellX); dispid 4;
    property Units: Integer dispid 9;
    property TickColor: OLE_COLOR dispid 10;
    property RowCount: Integer dispid 11;
    property RowHeight: Integer dispid 12;
    property RowLineWidth: Integer dispid 13;
    property UnitWidth: Integer dispid 14;
    property FrameWidth: Integer dispid 15;
    property CellFrameWidth: Integer dispid 16;
    property CellBorderWidth: Integer dispid 17;
    property DefaultDrawing: WordBool dispid 18;
    property CheckPosition: WordBool dispid 19;
    property CrossBorders: WordBool dispid 20;
    property MinVisible: Integer dispid 21;
    property RowLineColor: OLE_COLOR dispid 22;
    property CellColor: OLE_COLOR dispid 23;
    property Ctl3D: WordBool dispid 24;
    property ParentCtl3D: WordBool dispid 25;
    property Color: OLE_COLOR dispid -501;
    property DragCursor: Smallint dispid 26;
    property DragMode: TxDragMode dispid 27;
    property Enabled: WordBool dispid -514;
    property Font: IFontDisp dispid -512;
    property ParentColor: WordBool dispid 28;
    property Visible: WordBool dispid 29;
    property DoubleBuffered: WordBool dispid 30;
    property AlignDisabled: WordBool readonly dispid 31;
    property VisibleDockClientCount: Integer readonly dispid 32;
    function  DrawTextBiDiModeFlagsReadingOnly: Integer; dispid 34;
    function  IsRightToLeft: WordBool; dispid 36;
    function  UseRightToLeftReading: WordBool; dispid 39;
    function  UseRightToLeftScrollBar: WordBool; dispid 40;
    procedure SetSubComponent(IsSubComponent: WordBool); dispid 42;
    procedure GetCellArray(out RowCells: {??PSafeArray}OleVariant; out ArraySize: Integer; 
                           Row: Integer); dispid 2;
    procedure InsertRowCell(Row: Integer; Start: Integer; Units: Integer; Zorder: Integer; 
                            var ObjectPtr: {??Pointer}OleVariant); dispid 3;
    procedure RemoveRowCell(const RowCellX: IRowCellX); dispid 5;
    procedure MouseToCell(out RowCellX: IRowCellX; X: Integer; Y: Integer; 
                          out CellState: TxCellState); dispid 7;
    property ClientWidth: Integer dispid 8;
    property ClientHeight: Integer dispid 33;
    property HDC: {??Pointer}OleVariant readonly dispid 6;
    procedure ClearRow(Row: Integer); dispid 35;
    property VerticalRows: WordBool dispid 37;
    property AllowAltKey: WordBool dispid 38;
    property AllowShiftKey: WordBool dispid 41;
  end;

// *********************************************************************//
// DispIntf:  IRowGridXEvents
// Flags:     (4096) Dispatchable
// GUID:      {6A7E7D31-E04C-4D89-B086-5FDE2D6921DB}
// *********************************************************************//
  IRowGridXEvents = dispinterface
    ['{6A7E7D31-E04C-4D89-B086-5FDE2D6921DB}']
    procedure OnKeyPress(var Key: Smallint); dispid 11;
    procedure OnCanResize(var NewWidth: Integer; var NewHeight: Integer; var Resize: WordBool); dispid 14;
    procedure OnClick; dispid 15;
    procedure OnConstrainedResize(var MinWidth: Integer; var MinHeight: Integer; 
                                  var MaxWidth: Integer; var MaxHeight: Integer); dispid 16;
    procedure OnDblClick; dispid 18;
    procedure OnResize; dispid 29;
    procedure OnInsertRowCell(const RowCellX: IRowCellX; var CanInsert: WordBool); dispid 1;
    procedure OnRemoveRowCell(const RowCellX: IRowCellX; var CanRemove: WordBool); dispid 2;
    procedure OnDrawRowCell(const RowCellX: IRowCellX; const RectX: IRectX); dispid 3;
    procedure OnDragRowCell(const RowCellX: IRowCellX; CellState: TxCellState; IsCopy: WordBool; 
                            var CanDrag: WordBool); dispid 4;
    procedure OnDblClickRowCell(const RowCellX: IRowCellX); dispid 6;
    procedure OnMouseDown(MouseButton: TxMouseButton; ShiftState: Byte; X: Integer; Y: Integer); dispid 7;
    procedure OnMouseUp(MouseButton: TxMouseButton; ShiftState: Byte; X: Integer; Y: Integer); dispid 8;
    procedure OnMouseMove(ShiftState: Byte; X: Integer; Y: Integer); dispid 9;
    procedure OnKeyDown(var Key: {??Word}OleVariant; ShiftState: Byte); dispid 10;
    procedure OnDrawRowLine(const Rect: IRectX; Row: Integer); dispid 12;
    procedure OnClearRowCell(const RowCellX: IRowCellX; var CanClear: WordBool); dispid 13;
  end;

// *********************************************************************//
// Interface: IRowCellX
// Flags:     (256) OleAutomation
// GUID:      {12F262C0-20DE-4A15-9EE7-189E98A8BF20}
// *********************************************************************//
  IRowCellX = interface(IUnknown)
    ['{12F262C0-20DE-4A15-9EE7-189E98A8BF20}']
    function  Get_Row(out Value: Integer): HResult; stdcall;
    function  Set_Row(Value: Integer): HResult; stdcall;
    function  Get_Start(out Value: Integer): HResult; stdcall;
    function  Set_Start(Value: Integer): HResult; stdcall;
    function  Get_Units(out Value: Integer): HResult; stdcall;
    function  Set_Units(Value: Integer): HResult; stdcall;
    function  Get_Zorder(out Value: Integer): HResult; stdcall;
    function  Set_Zorder(Value: Integer): HResult; stdcall;
    function  Get_ObjectPtr(out Value: Pointer): HResult; stdcall;
    function  Set_ObjectPtr(Value: Pointer): HResult; stdcall;
    function  equals(out IsEqual: WordBool; const RowCellX: IRowCellX): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IRectX
// Flags:     (256) OleAutomation
// GUID:      {346DE116-0A7F-4392-BD6F-6091FE2D9DA7}
// *********************************************************************//
  IRectX = interface(IUnknown)
    ['{346DE116-0A7F-4392-BD6F-6091FE2D9DA7}']
    function  Get_Left(out Value: Integer): HResult; stdcall;
    function  Set_Left(Value: Integer): HResult; stdcall;
    function  Get_Top(out Value: Integer): HResult; stdcall;
    function  Set_Top(Value: Integer): HResult; stdcall;
    function  Get_Right(out Value: Integer): HResult; stdcall;
    function  Set_Right(Value: Integer): HResult; stdcall;
    function  Get_Bottom(out Value: Integer): HResult; stdcall;
    function  Set_Bottom(Value: Integer): HResult; stdcall;
  end;


// *********************************************************************//
// OLE Control Proxy class declaration
// Control Name     : TRowGridX
// Help String      : RowGridX Control
// Default Interface: IRowGridX
// Def. Intf. DISP? : No
// Event   Interface: IRowGridXEvents
// TypeFlags        : (38) CanCreate Licensed Control
// *********************************************************************//
  TRowGridXOnKeyPress = procedure(Sender: TObject; var Key: Smallint) of object;
  TRowGridXOnCanResize = procedure(Sender: TObject; var NewWidth: Integer; var NewHeight: Integer; 
                                                    var Resize: WordBool) of object;
  TRowGridXOnConstrainedResize = procedure(Sender: TObject; var MinWidth: Integer; 
                                                            var MinHeight: Integer; 
                                                            var MaxWidth: Integer; 
                                                            var MaxHeight: Integer) of object;
  TRowGridXOnInsertRowCell = procedure(Sender: TObject; const RowCellX: IRowCellX; 
                                                        var CanInsert: WordBool) of object;
  TRowGridXOnRemoveRowCell = procedure(Sender: TObject; const RowCellX: IRowCellX; 
                                                        var CanRemove: WordBool) of object;
  TRowGridXOnDrawRowCell = procedure(Sender: TObject; const RowCellX: IRowCellX; const RectX: IRectX) of object;
  TRowGridXOnDragRowCell = procedure(Sender: TObject; const RowCellX: IRowCellX; 
                                                      CellState: TxCellState; IsCopy: WordBool; 
                                                      var CanDrag: WordBool) of object;
  TRowGridXOnDblClickRowCell = procedure(Sender: TObject; const RowCellX: IRowCellX) of object;
  TRowGridXOnMouseDown = procedure(Sender: TObject; MouseButton: TxMouseButton; ShiftState: Byte; 
                                                    X: Integer; Y: Integer) of object;
  TRowGridXOnMouseUp = procedure(Sender: TObject; MouseButton: TxMouseButton; ShiftState: Byte; 
                                                  X: Integer; Y: Integer) of object;
  TRowGridXOnMouseMove = procedure(Sender: TObject; ShiftState: Byte; X: Integer; Y: Integer) of object;
  TRowGridXOnKeyDown = procedure(Sender: TObject; var Key: {??Word}OleVariant; ShiftState: Byte) of object;
  TRowGridXOnDrawRowLine = procedure(Sender: TObject; const Rect: IRectX; Row: Integer) of object;
  TRowGridXOnClearRowCell = procedure(Sender: TObject; const RowCellX: IRowCellX; 
                                                       var CanClear: WordBool) of object;

  TRowGridX = class(TOleControl)
  private
    FOnKeyPress: TRowGridXOnKeyPress;
    FOnCanResize: TRowGridXOnCanResize;
    FOnClick: TNotifyEvent;
    FOnConstrainedResize: TRowGridXOnConstrainedResize;
    FOnDblClick: TNotifyEvent;
    FOnResize: TNotifyEvent;
    FOnInsertRowCell: TRowGridXOnInsertRowCell;
    FOnRemoveRowCell: TRowGridXOnRemoveRowCell;
    FOnDrawRowCell: TRowGridXOnDrawRowCell;
    FOnDragRowCell: TRowGridXOnDragRowCell;
    FOnDblClickRowCell: TRowGridXOnDblClickRowCell;
    FOnMouseDown: TRowGridXOnMouseDown;
    FOnMouseUp: TRowGridXOnMouseUp;
    FOnMouseMove: TRowGridXOnMouseMove;
    FOnKeyDown: TRowGridXOnKeyDown;
    FOnDrawRowLine: TRowGridXOnDrawRowLine;
    FOnClearRowCell: TRowGridXOnClearRowCell;
    FIntf: IRowGridX;
    function  GetControlInterface: IRowGridX;
  protected
    procedure CreateControl;
    procedure InitControlData; override;
    function  Get_HDC: Pointer;
  public
    procedure ClearDragState(out RowCellX: IRowCellX);
    function  DrawTextBiDiModeFlagsReadingOnly: Integer;
    function  IsRightToLeft: WordBool;
    function  UseRightToLeftReading: WordBool;
    function  UseRightToLeftScrollBar: WordBool;
    procedure SetSubComponent(IsSubComponent: WordBool);
    procedure GetCellArray(out RowCells: PSafeArray; out ArraySize: Integer; Row: Integer);
    procedure InsertRowCell(Row: Integer; Start: Integer; Units: Integer; Zorder: Integer; 
                            ObjectPtr: Pointer);
    procedure RemoveRowCell(const RowCellX: IRowCellX);
    procedure MouseToCell(out RowCellX: IRowCellX; X: Integer; Y: Integer; 
                          out CellState: TxCellState);
    procedure ClearRow(Row: Integer);
    property  ControlInterface: IRowGridX read GetControlInterface;
    property  DefaultInterface: IRowGridX read GetControlInterface;
    property DragState: TOleEnum index 1 read GetTOleEnumProp;
    property DoubleBuffered: WordBool index 30 read GetWordBoolProp write SetWordBoolProp;
    property AlignDisabled: WordBool index 31 read GetWordBoolProp;
    property VisibleDockClientCount: Integer index 32 read GetIntegerProp;
    property HDC: Pointer read Get_HDC;
  published
    property  ParentFont;
    property  TabStop;
    property  Align;
    property  ParentShowHint;
    property  PopupMenu;
    property  ShowHint;
    property  TabOrder;
    property  OnDragDrop;
    property  OnDragOver;
    property  OnEndDrag;
    property  OnEnter;
    property  OnExit;
    property  OnStartDrag;
    property Units: Integer index 9 read GetIntegerProp write SetIntegerProp stored False;
    property TickColor: TColor index 10 read GetTColorProp write SetTColorProp stored False;
    property RowCount: Integer index 11 read GetIntegerProp write SetIntegerProp stored False;
    property RowHeight: Integer index 12 read GetIntegerProp write SetIntegerProp stored False;
    property RowLineWidth: Integer index 13 read GetIntegerProp write SetIntegerProp stored False;
    property UnitWidth: Integer index 14 read GetIntegerProp write SetIntegerProp stored False;
    property FrameWidth: Integer index 15 read GetIntegerProp write SetIntegerProp stored False;
    property CellFrameWidth: Integer index 16 read GetIntegerProp write SetIntegerProp stored False;
    property CellBorderWidth: Integer index 17 read GetIntegerProp write SetIntegerProp stored False;
    property DefaultDrawing: WordBool index 18 read GetWordBoolProp write SetWordBoolProp stored False;
    property CheckPosition: WordBool index 19 read GetWordBoolProp write SetWordBoolProp stored False;
    property CrossBorders: WordBool index 20 read GetWordBoolProp write SetWordBoolProp stored False;
    property MinVisible: Integer index 21 read GetIntegerProp write SetIntegerProp stored False;
    property RowLineColor: TColor index 22 read GetTColorProp write SetTColorProp stored False;
    property CellColor: TColor index 23 read GetTColorProp write SetTColorProp stored False;
    property Ctl3D: WordBool index 24 read GetWordBoolProp write SetWordBoolProp stored False;
    property ParentCtl3D: WordBool index 25 read GetWordBoolProp write SetWordBoolProp stored False;
    property Color: TColor index -501 read GetTColorProp write SetTColorProp stored False;
    property DragCursor: Smallint index 26 read GetSmallintProp write SetSmallintProp stored False;
    property DragMode: TOleEnum index 27 read GetTOleEnumProp write SetTOleEnumProp stored False;
    property Enabled: WordBool index -514 read GetWordBoolProp write SetWordBoolProp stored False;
    property Font: TFont index -512 read GetTFontProp write _SetTFontProp stored False;
    property ParentColor: WordBool index 28 read GetWordBoolProp write SetWordBoolProp stored False;
    property Visible: WordBool index 29 read GetWordBoolProp write SetWordBoolProp stored False;
    property ClientWidth: Integer index 8 read GetIntegerProp write SetIntegerProp stored False;
    property ClientHeight: Integer index 33 read GetIntegerProp write SetIntegerProp stored False;
    property VerticalRows: WordBool index 37 read GetWordBoolProp write SetWordBoolProp stored False;
    property AllowAltKey: WordBool index 38 read GetWordBoolProp write SetWordBoolProp stored False;
    property AllowShiftKey: WordBool index 41 read GetWordBoolProp write SetWordBoolProp stored False;
    property OnKeyPress: TRowGridXOnKeyPress read FOnKeyPress write FOnKeyPress;
    property OnCanResize: TRowGridXOnCanResize read FOnCanResize write FOnCanResize;
    property OnClick: TNotifyEvent read FOnClick write FOnClick;
    property OnConstrainedResize: TRowGridXOnConstrainedResize read FOnConstrainedResize write FOnConstrainedResize;
    property OnDblClick: TNotifyEvent read FOnDblClick write FOnDblClick;
    property OnResize: TNotifyEvent read FOnResize write FOnResize;
    property OnInsertRowCell: TRowGridXOnInsertRowCell read FOnInsertRowCell write FOnInsertRowCell;
    property OnRemoveRowCell: TRowGridXOnRemoveRowCell read FOnRemoveRowCell write FOnRemoveRowCell;
    property OnDrawRowCell: TRowGridXOnDrawRowCell read FOnDrawRowCell write FOnDrawRowCell;
    property OnDragRowCell: TRowGridXOnDragRowCell read FOnDragRowCell write FOnDragRowCell;
    property OnDblClickRowCell: TRowGridXOnDblClickRowCell read FOnDblClickRowCell write FOnDblClickRowCell;
    property OnMouseDown: TRowGridXOnMouseDown read FOnMouseDown write FOnMouseDown;
    property OnMouseUp: TRowGridXOnMouseUp read FOnMouseUp write FOnMouseUp;
    property OnMouseMove: TRowGridXOnMouseMove read FOnMouseMove write FOnMouseMove;
    property OnKeyDown: TRowGridXOnKeyDown read FOnKeyDown write FOnKeyDown;
    property OnDrawRowLine: TRowGridXOnDrawRowLine read FOnDrawRowLine write FOnDrawRowLine;
    property OnClearRowCell: TRowGridXOnClearRowCell read FOnClearRowCell write FOnClearRowCell;
  end;

// *********************************************************************//
// The Class CoRowCellX provides a Create and CreateRemote method to          
// create instances of the default interface IRowCellX exposed by              
// the CoClass RowCellX. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoRowCellX = class
    class function Create: IRowCellX;
    class function CreateRemote(const MachineName: string): IRowCellX;
  end;

// *********************************************************************//
// The Class CoRectX provides a Create and CreateRemote method to          
// create instances of the default interface IRectX exposed by              
// the CoClass RectX. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoRectX = class
    class function Create: IRectX;
    class function CreateRemote(const MachineName: string): IRectX;
  end;

procedure Register;

resourcestring
  dtlServerPage = 'ActiveX';

implementation

uses ComObj;

procedure TRowGridX.InitControlData;
const
  CEventDispIDs: array [0..16] of DWORD = (
    $0000000B, $0000000E, $0000000F, $00000010, $00000012, $0000001D,
    $00000001, $00000002, $00000003, $00000004, $00000006, $00000007,
    $00000008, $00000009, $0000000A, $0000000C, $0000000D);
  CLicenseKey: array[0..38] of Word = ( $007B, $0036, $0038, $0031, $0041, $0041, $0045, $0032, $0036, $002D, $0038
    , $0037, $0039, $0046, $002D, $0034, $0046, $0031, $0041, $002D, $0042
    , $0032, $0041, $0033, $002D, $0044, $0045, $0043, $0044, $0032, $0041
    , $0035, $0046, $0035, $0042, $0039, $0037, $007D, $0000);
  CTFontIDs: array [0..0] of DWORD = (
    $FFFFFE00);
  CControlData: TControlData2 = (
    ClassID: '{453EF49A-BA60-48E8-800D-46116526C471}';
    EventIID: '{6A7E7D31-E04C-4D89-B086-5FDE2D6921DB}';
    EventCount: 17;
    EventDispIDs: @CEventDispIDs;
    LicenseKey: @CLicenseKey;
    Flags: $0000000D;
    Version: 401;
    FontCount: 1;
    FontIDs: @CTFontIDs);
begin
  ControlData := @CControlData;
  TControlData2(CControlData).FirstEventOfs := Cardinal(@@FOnKeyPress) - Cardinal(Self);
end;

procedure TRowGridX.CreateControl;

  procedure DoCreate;
  begin
    FIntf := IUnknown(OleObject) as IRowGridX;
  end;

begin
  if FIntf = nil then DoCreate;
end;

function TRowGridX.GetControlInterface: IRowGridX;
begin
  CreateControl;
  Result := FIntf;
end;

function  TRowGridX.Get_HDC: Pointer;
begin
  Result := DefaultInterface.HDC;
end;

procedure TRowGridX.ClearDragState(out RowCellX: IRowCellX);
begin
  DefaultInterface.ClearDragState(RowCellX);
end;

function  TRowGridX.DrawTextBiDiModeFlagsReadingOnly: Integer;
begin
  Result := DefaultInterface.DrawTextBiDiModeFlagsReadingOnly;
end;

function  TRowGridX.IsRightToLeft: WordBool;
begin
  Result := DefaultInterface.IsRightToLeft;
end;

function  TRowGridX.UseRightToLeftReading: WordBool;
begin
  Result := DefaultInterface.UseRightToLeftReading;
end;

function  TRowGridX.UseRightToLeftScrollBar: WordBool;
begin
  Result := DefaultInterface.UseRightToLeftScrollBar;
end;

procedure TRowGridX.SetSubComponent(IsSubComponent: WordBool);
begin
  DefaultInterface.SetSubComponent(IsSubComponent);
end;

procedure TRowGridX.GetCellArray(out RowCells: PSafeArray; out ArraySize: Integer; Row: Integer);
begin
  DefaultInterface.GetCellArray(RowCells, ArraySize, Row);
end;

procedure TRowGridX.InsertRowCell(Row: Integer; Start: Integer; Units: Integer; Zorder: Integer; 
                                  ObjectPtr: Pointer);
begin
  DefaultInterface.InsertRowCell(Row, Start, Units, Zorder, ObjectPtr);
end;

procedure TRowGridX.RemoveRowCell(const RowCellX: IRowCellX);
begin
  DefaultInterface.RemoveRowCell(RowCellX);
end;

procedure TRowGridX.MouseToCell(out RowCellX: IRowCellX; X: Integer; Y: Integer; 
                                out CellState: TxCellState);
begin
  DefaultInterface.MouseToCell(RowCellX, X, Y, CellState);
end;

procedure TRowGridX.ClearRow(Row: Integer);
begin
  DefaultInterface.ClearRow(Row);
end;

class function CoRowCellX.Create: IRowCellX;
begin
  Result := CreateComObject(CLASS_RowCellX) as IRowCellX;
end;

class function CoRowCellX.CreateRemote(const MachineName: string): IRowCellX;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_RowCellX) as IRowCellX;
end;

class function CoRectX.Create: IRectX;
begin
  Result := CreateComObject(CLASS_RectX) as IRectX;
end;

class function CoRectX.CreateRemote(const MachineName: string): IRectX;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_RectX) as IRectX;
end;

procedure Register;
begin
  RegisterComponents('ActiveX',[TRowGridX]);
end;

end.
