//$Id: testgrid.h,v 1.4 2006/01/09 17:43:49 darseq Exp $
#ifndef testgridH
#define testgridH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "RowGrid.h"
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TMemo *Memo1;
	TRowGrid *RowGrid1;
	TButton *Button1;
	void __fastcall RowGrid1DragRowCell(TObject *Sender, RowCell RowCell,
          TCellState CellState, bool IsCopy, bool &CanDrag);
	void __fastcall RowGrid1DrawRowCell(TObject *Sender, RowCell RowCell,
		  TRect Rect);
	void __fastcall RowGrid1DblClickRowCell(TObject *Sender, RowCell RowCell);
	void __fastcall RowGrid1InsertRowCell(TObject *Sender, RowCell &RowCell,
		  bool &CanInsert);
	void __fastcall RowGrid1RemoveRowCell(TObject *Sender, RowCell &RowCell,
		  bool &CanRemove);
	void __fastcall Button1Click(TObject *Sender);
	void __fastcall RowGrid1MouseMove(TObject *Sender, TShiftState Shift,
		  int X, int Y);
private:	// User declarations
	AnsiString __fastcall CellToString(RowCell & RowCell);
	AnsiString __fastcall CellStateToString(TCellState CellState);
	AnsiString __fastcall DragStateToString(Rowgrid::TDragState state);
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
	__fastcall ~TForm1(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
